var originX = 0;
var originY = 0;
var mousePrevX = 0;
var mousePrevY = 0;
var button = "NONE";
var countContours = 0;
var Coords1 = new Array();

var trX = 0;
var trY = 0;

function drawCoordinateSystem(canvas) {
    if (canvas.getContext) {
        var context = canvas.getContext("2d");
        var dashList = [5, 2];  // Create 3x3 dots and spaces
        context.setLineDash(dashList);
        context.lineWidth = 1;
        context.beginPath();
        context.strokeStyle = '#EDEDED';
        for (i = 1; i < 15; i++) {
            context.moveTo(0, i*40);
            context.lineTo(900, i*40);
        }
        for (i = -10; i <=10; i++) {
            context.moveTo(450 + i*40.178, 0);
            context.lineTo(450 + i*40.178, 600);
        }
        context.stroke();
    }
}

// Основная функция
function load(id, Coords) {
    var canvas;

    canvas = document.getElementById(id);
    if (!canvas.getContext) return;

    if (canvas.addEventListener)
        canvas.addEventListener('DOMMouseScroll', wheel, false);
    canvas.onmousewheel = wheel;
    canvas.onmouseup = up;
    canvas.onmousedown = down;
    canvas.onmousemove = move;

    var DirZoom = document.createAttribute('dirzoom');
    DirZoom.nodeValue = 0;
    canvas.attributes.setNamedItem(DirZoom);

    var Zoom = document.createAttribute('zoom');
    Zoom.nodeValue = 1;
    canvas.attributes.setNamedItem(Zoom);

    var Width = document.createAttribute('widthcanvas');
    Width.nodeValue = 900;
    canvas.attributes.setNamedItem(Width);

    var Height = document.createAttribute('heightcanvas');
    Height.nodeValue = 600;
    canvas.attributes.setNamedItem(Height);

    draw(canvas, 0, 0, Coords, id);
};

// Рисование на канвасе массива точек
function draw(canvas, k, m, Coords, id) {
    var zoom = canvas.attributes.getNamedItem('zoom');
    var widthAttr = canvas.attributes.getNamedItem('widthcanvas');
    var heightAttr = canvas.attributes.getNamedItem('heightcanvas');

    var width = parseInt(widthAttr.nodeValue);
    var height = parseInt(heightAttr.nodeValue);

    if (m == 1) {
       if (k > 0 && zoom.nodeValue < 100) {

           xc = 450 - trX;
           yc = 300 - trY;
            
           kx = xc / width;
           ky = yc / height;

           trX = trX - 900 * kx;
           trY = trY - 600 * ky;


           width += 900;
           height += 600;
           zoom.nodeValue++;
           var context = canvas.getContext('2d');
            
           context.translate(originX - 900 * kx, originY - 600 * ky);
           
//           trX = trX - 450;
//           trY = trY - 300;
//           context.translate(originX - 450, originY - 300);

       } 
       if (k < 0 && zoom.nodeValue > 1) {

           xc = 450 - trX;
           yc = 300 - trY;
            
           kx = xc / width;
           ky = yc / height;
           trX = trX + 900 * kx;
           trY = trY + 600 * ky;


           width -= 900;
           height -= 600;
           zoom.nodeValue--;  
           var context = canvas.getContext('2d');

           context.translate(originX + 900 * kx, originY + 600 * ky);

//           trX = trX + 450;
//           trY = trY + 300;
//           context.translate(originX + 450, originY + 300);

       } else if (k < 0 && zoom.nodeValue == 1) {
           var context = canvas.getContext('2d');
           context.translate(originX - trX, originY - trY);

           trX = 0;
           trY = 0;
       }
    }

    widthAttr.nodeValue = width;
    heightAttr.nodeValue = height;

    canvas.attributes.setNamedItem(zoom);
    canvas.attributes.setNamedItem(widthAttr);
    canvas.attributes.setNamedItem(heightAttr);

    countContours = 0;

    if (id == "canvas1") { minX = minX1; maxX = maxX1; minY = minY1; maxY = maxY1; }

    drawAll(canvas, width, height, Coords, minX, maxX, minY, maxY);

   
    if (trX == 0 && trY == 0 && zoom.nodeValue == 1) {
        drawCoordinateSystem(canvas);
    }
};

// Отрисовка всех контуров
function drawAll(canvas, width, height, Coords, minX, maxX, minY, maxY) {

    var context = canvas.getContext('2d');

    context.clearRect(-1000, -1000, width + 2000, height + 2000);
    context.strokeStyle = "Black";

    var cX = maxY - minY;
    var cY = maxX - minX;

    // Коэффициент масштабирования
    var koef;
    var koefX = cX / width;
    var koefY = cY / height;
    if (koefX < koefY) koef = koefY; else koef = koefX;

    for (var i = Coords.length - 1; i >= 0; i--) {
        var polygon = [];
        context.save();
        context.beginPath();

        var dashList = [10, 0];  // Create 3x3 dots and spaces
        context.setLineDash(dashList);

        for (var z = 0; z < Coords[i].length; z++) {
            x1 = (maxX - Coords[i][z][1]) / koef;
            y1 = (Coords[i][z][2] - minY) / koef;

            context.moveTo(y1, x1);
            for (var j = 1; j < Coords[i][z].length / 2; j++) {
                x2 = (maxX - Coords[i][z][(j * 2) - 1]) / koef;
                y2 = (Coords[i][z][j * 2] - minY) / koef;

                context.lineTo(y2, x2);
                polygon[j - 1] = new Point(y2, x2);
            }
//            context.lineTo(y1, x1);
//            context.closePath();
        }

        context.stroke();
        context.restore();

        countContours++;

        var center = (new Contour(polygon)).centroid();
        var zoom = canvas.attributes.getNamedItem('zoom');
         
        var cType = Coords[i][0][0].substring(0,1);
        if (cType == 'A') {
            context.fillStyle = "Gray";
            context.fillText(Coords[i][0][0].substring(1), center.x - (0.5 * context.measureText(Coords[i][0][0].substring(1)).width), center.y);
        }
        if (cType == 'B' && zoom.nodeValue > 7) {
            context.fillStyle = "Gray";
            context.fillText(Coords[i][0][0].substring(1), center.x - (0.5 * context.measureText(Coords[i][0][0].substring(1)).width), center.y);
        }
        if (cType == 'C' && zoom.nodeValue > 15) {
            context.fillStyle = "Gray";
            context.fillText(Coords[i][0][0].substring(1), center.x - (0.5 * context.measureText(Coords[i][0][0].substring(1)).width), center.y);
        }
        if (cType == 'D' && zoom.nodeValue > 25) {
            context.fillStyle = "Gray";
            context.fillText(Coords[i][0][0].substring(1), center.x - (0.5 * context.measureText(Coords[i][0][0].substring(1)).width), center.y);
        }
        if (cType == 'E' && zoom.nodeValue > 50) {
            context.fillStyle = "Gray";
            context.fillText(Coords[i][0][0].substring(1), center.x - (0.5 * context.measureText(Coords[i][0][0].substring(1)).width), center.y);
        }
    }
};
// Точка центроида
function Point(x, y) {
    this.x = x;
    this.y = y;
};
// Контур объекта
function Contour(a) {
    this.pts = a || [];
};
// Площадь объекта
Contour.prototype.area = function () {
    var area = 0;
    var pts = this.pts;
    var nPts = pts.length;
    var j = nPts - 1;
    var p1; var p2;

    for (var i = 0; i < nPts; j = i++) {
        p1 = pts[i]; p2 = pts[j];
        area += p1.x * p2.y;
        area -= p1.y * p2.x;
    }
    area /= 2;
    return area;
};
// Центроид объекта
Contour.prototype.centroid = function () {
    var pts = this.pts;
    var nPts = pts.length;
    var x = 0; var y = 0;
    var f;
    var j = nPts - 1;
    var p1; var p2;

    for (var i = 0; i < nPts; j = i++) {
        p1 = pts[i]; p2 = pts[j];
        f = p1.x * p2.y - p2.x * p1.y;
        x += (p1.x + p2.x) * f;
        y += (p1.y + p2.y) * f;
    }

    f = this.area() * 6;
    return new Point(x / f, y / f);
};

// Обработчик колеса мыши
function wheel(event) {
    var wDelta = 0;
    if (!event)
        event = window.event;
    if (event.wheelDelta) {
        wDelta = event.wheelDelta / 120;
        if (window.opera)
            wDelta = -wDelta;
    } else if (event.detail) {
        wDelta = -event.detail / 3;
    }

    if (this.id == "canvas1") { draw(this, wDelta, 1, Coords1, this.id); }

    this.attributes.getNamedItem('dirzoom').nodeValue = wDelta;

    // Для прокрутки только над канвасом
    if (event.preventDefault) {
        event.preventDefault();
    }
    event.returnValue = false;
};
function move(event) {
    if (!event)
        event = window.event;
    if (event != undefined) {
        if (button == "LEFT") {
            var mouseX = event.clientX - this.offsetLeft;
            var mouseY = event.clientY - this.offsetTop;

            var zoom = this.attributes.getNamedItem('zoom');

            context = this.getContext('2d');

            if (mousePrevX > 0) {
                var dx = mouseX - mousePrevX;
                var dy = mouseY - mousePrevY;
                if (dx > 50) dx = 50;
                if (dx < -50) dx = -50;
                if (dy > 50) dy = 50;
                if (dy < -50) dy = -50;

                context.translate(originX + dx, originY + dy);

                trX = trX + dx;
                trY = trY + dy;

            }

/*
            if (mousePrevX > mouseX)
                context.translate(originX - zoom.nodeValue * 5, originY);
            if (mousePrevX < mouseX)
                context.translate(originX + zoom.nodeValue * 5, originY);
            if (mousePrevY > mouseY)
                context.translate(originX, originY - zoom.nodeValue * 5);
            if (mousePrevY < mouseY)
                context.translate(originX, originY + zoom.nodeValue * 5);
*/
            mousePrevX = mouseX;
            mousePrevY = mouseY;

            // Если объектов не много, будем рисовать в режиме "онлайн"
            //if (countContours < 200)
            if (this.id == "canvas1") { draw(this, this.attributes.getNamedItem('dirzoom').nodeValue, 0, Coords1, this.id); }

        } else {
            mousePrevX = -1;
            mousePrevY = -1;
        }

        // Для перемещения только над канвасом
        if (event.preventDefault) {
            event.preventDefault();
        }
        event.returnValue = false;
    }
};
function up(event) {
    button = "NONE";
    // Если много объектов, то перерисовывать лучше после отпускания кнопки мыши
    //if (countContours >= 200)
    //    draw(savedZoom, 0);
};
function down(event) {
    // Либо IE, либо другой
    if (!event)
        event = window.event;
    if (event != undefined) {
        if (event.which == null)
            button = (event.button < 2) ? "LEFT" :
                ((event.button == 4) ? "MIDDLE" : "RIGHT");
        else
            button = (event.which < 2) ? "LEFT" :
                ((event.which == 2) ? "MIDDLE" : "RIGHT");
    }
};